<?php
/*
 * Список наименований игровых комнат.
 */
trait Rooms
{
    public static $roomNames = [
        0 => "Секретная Комната",
        1 => "Дом поединков",
        20 => "Центральная площадь",
        21 => "Страшилкина улица",
        22 => "Магазин",
        23 => "Ремонтная мастерская",
        24 => "Памятник Архангелу",
        25 => "Комиссионный магазин",
        26 => "Большая парковая улица",
        27 => "Почта",
        28 => "Регистратура кланов",
        29 => "Банк",
        30 => "Регистратура кланов (мираж)",
        31 => "Башня смерти",
        32 => "Готический замок",
        33 => "Лабиринт хаоса",
        34 => "Цветочный магазин",
        35 => "Сувенирный магазин",
        37 => "Готический замок - приемная",
        38 => "Готический замок - арсенал",
        39 => "Готический замок - внутренний двор",
        40 => "Готический замок - мастерские",
        41 => "Готический замок - комнаты отдыха",
        42 => "Лотерея Сталкеров",
        43 => "Хижина Знахаря",
        44 => "Новогодняя елка",
        45 => "Замок Мэра",
        47 => "Замок (строительство)",
        48 => "Обитель Хаоса",
        49 => "Проход к Цитадели Хаоса",
        51 => "Парковая улица",
        52 => "Квартал Законников",
        53 => "Библиотека",
        200 => "Турнир",
        401 => "Врата Ада",
        // БС
        501 => "Восточная Крыша",
        502 => "Бойница",
        503 => "Келья 3",
        504 => "Келья 2",
        505 => "Западная Крыша 2",
        506 => "Келья 4",
        507 => "Келья 1",
        508 => "Служебная комната",
        509 => "Зал Отдыха 2",
        510 => "Западная Крыша 1",
        511 => "Выход на Крышу",
        512 => "Зал Статуй 2",
        513 => "Храм",
        514 => "Восточная комната",
        515 => "Зал Отдыха 1",
        516 => "Старый Зал 2",
        517 => "Старый Зал 1",
        518 => "Красный Зал 3",
        519 => "Зал Статуй 1",
        520 => "Зал Статуй 3",
        521 => "Трапезная 3",
        522 => "Зал Ожиданий",
        523 => "Оружейная",
        524 => "Красный Зал-Окна",
        525 => "Красный Зал",
        526 => "Гостинная",
        527 => "Трапезная 1",
        528 => "Внутренний Двор",
        529 => "Внутр.Двор-Вход",
        530 => "Желтый Коридор",
        531 => "Мраморный Зал 1",
        532 => "Красный Зал 2",
        533 => "Библиотека 1",
        534 => "Трапезная 2",
        535 => "Проход Внутр. Двора",
        536 => "Комната с Камином",
        537 => "Библиотека 3",
        538 => "Выход из Мрам.Зала",
        539 => "Красный Зал-Коридор",
        540 => "Лестница в Подвал 1",
        541 => "Южный Внутр. Двор",
        542 => "Трапезная 4",
        543 => "Мраморный Зал 3",
        544 => "Мраморный Зал 2",
        545 => "Картинная Галерея 1",
        546 => "Лестница в Подвал 2",
        547 => "Проход Внутр. Двора 2",
        548 => "Внутр.Двор-Выход",
        549 => "Библиотека 2",
        550 => "Картинная Галерея 3",
        551 => "Картинная Галерея 2",
        552 => "Лестница в Подвал 3",
        553 => "Терасса",
        554 => "Оранжерея",
        555 => "Зал Ораторов",
        556 => "Лестница в Подвал 4",
        557 => "Темная Комната",
        558 => "Винный Погреб",
        559 => "Комната в Подвале",
        560 => "Подвал",
        600 => "Вход в Цитадель Хаоса",
        601 => "Цитадель Хаоса",
        602 => "Городской парк",
        603 => "Арена Ангелов",
        620 => "Вход в Рудник",
        621 => "Рудник",
        660 => "Гостиница, холл",
        661 => "Гостиница",
        662 => "Памятник Архангелу",
        // Клановая улица
        650 => "Клановая улица",
        651 => "Клановая улица",
        652 => "Клановый Замок",
        760 => "Тёмный Лес",
        1000 => "Вход в рудник",
        1001 => "Рудник",
        1051 => "Вход в Лабиринты",
        1052 => "Лабиринты",
        1053 => "Храмовая лавка",
        1054 => "Фонтан Удачи",
        1055 => "Групповое сражение",
        // Тайный проход из Клуба в Замок Законников
        2000 => "Подземный проход",
        2001 => "Подземный проход (1)",
        2002 => "Подземный проход (2)",
        2003 => "Подземный проход (3)",
        2004 => "Подземный проход (4)",
        2005 => "Подземный проход (5)",
        2006 => "Подземный проход (6)",
        2007 => "Подземный проход (7)",
        2008 => "Подземный проход (8)",
        2009 => "Подземный проход (9)",
        2010 => "Подземный проход (10)",
        2011 => "Подземный проход (11)",
        2012 => "Подземный проход (12)",
        2013 => "Подземный проход (13)",
        2014 => "Подземный проход (14)",
        2015 => "Подземный проход (15)",
        2016 => "Подземный проход (16)",
        2017 => "Подземный проход (17)",
        2018 => "Подземный проход (18)",
        2019 => "Подземный проход (19)",
        2020 => "Подземный проход (20)",
        2021 => "Подземный проход (21)",
        2022 => "Подземный проход (22)",
        2023 => "Подземный проход (23)",
        2024 => "Подземный проход (24)",
        2025 => "Подземный проход (25)",
        2026 => "Подземный проход (26)",
        2027 => "Подземный проход (27)",
        2028 => "Подземный проход (28)",
        2029 => "Подземный проход (29)",
        2030 => "Подземный проход (30)",
        2031 => "Подземный проход (31)",
        2032 => "Подземный проход (32)",
        2033 => "Подземный проход (33)",
        2034 => "Подземный проход (34)",
        2035 => "Подземный проход (35)",
        2036 => "Подземный проход (36)",
        2037 => "Подземный проход (37)",
        2038 => "Подземный проход (38)",
        2039 => "Подземный проход (39)",
        2040 => "Подземный проход (40)",
        2041 => "Подземный проход (41)",
        2042 => "Подземный проход (42)",
        2043 => "Подземный проход (43)",
        2044 => "Подземный проход (44)",
        2045 => "Подземный проход (45)",
        2046 => "Подземный проход (46)",
        2047 => "Подземный проход (47)",
        2048 => "Подземный проход (48)",
        2049 => "Подземный проход (49)",
        2050 => "Подземный проход (50)",
        2051 => "Подземный проход (51)",
        2052 => "Подземный проход (52)",
        2053 => "Подземный проход (53)",
        2054 => "Подземный проход (54)",
        2055 => "Подземный проход (55)",
        2056 => "Подземный проход (56)",
        2057 => "Подземный проход (57)",
        2100 => "Сектор 2100",
        2655 => "Арена Богов",
        2601 => "Замковая Площадь",
        2702 => "Центральная площадь (мираж)",
    ] ?? "Небытие";
}